"""
contains DOM Level 2 CSSUnknownRule implementation class.

TODO
    cssText: fset not implemented yet
"""
__version__ = '0.53'

import exceptions 
import xml.dom
import cssrule


class UnknownRule(cssrule.CSSRule):
    """
    represents an at-rule not supported by this user agent.
    """    
    type = cssrule.CSSRule.UNKNOWN_RULE

    def __init__(self, text=u'', readonly=False):
        self._readonly = False
        self.cssText = text
        self._readonly = readonly

    # fget
    def getFormatted(self, indent=4, offset=0):
        "returns inherited property cssText prettyprinted"
        if self._text:
            return offset * u' ' + self._text
        else:
            return u''
    # fset
    def _setCssText(self, cssText):
        """
        sets inherited property cssText
        NOT IMPLEMENTED FULLY YET
        Exceptions on setting
            DOMException
            SYNTAX_ERR: Raised if the specified CSS string value has a
                syntax error and is unparsable.
            INVALID_MODIFICATION_ERR: Raised if the specified CSS string
                value represents a different type of rule than the current
                one.
            HIERARCHY_REQUEST_ERR: Raised if the rule cannot be inserted at
                this point in the style sheet.
        """
        if (self._readonly):
            raise xml.dom.NoModificationAllowedErr('CharsetRule is readonly')
        self._text = cssText
    # property
    cssText = property(fget=getFormatted, fset=_setCssText,
        doc="(DOM attribute) The parsable textual representation.")
